      SUBROUTINE J5INIVEC(N,V,JVBLK,NP,IP,JVS,JVE)
*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
*
* ARGUMENTS
*
      INTEGER N,NP,IP,JVS,JVE
      COMPLEX*16 V(N,*)
      INTEGER JVBLK(NP+1)
*
* ----------------------------------------------------------------------
*  PURPOSE
*  =======
*
*  J5INIVEC IS INITIALIZEID TO UNIT MATRIX V.
*
*  ARGUMENTS
*  =========
*
*  N       (INPUT) INTEGER
*          THE ORDER OF THE MATRIX.
*          N >= 2
*
*  V       (OUTPUT) COMPLEX*16 ARRAY, DIMENSION (LDA,*)
*          UNIT MATRIX.
*
*  JVBLK   (INPUT) INTEGER ARRAY, DIMENSION(NP+1).
*          GLOBAL ADDRESS LIST FOR EIGENVECTORS.
*
*  NP      (INPUT) INTEGER
*          TOTAL NUMBER OF MPI PROCESSES.
*
*  IP      (INPUT) INTEGER
*          NUMBER OF MPI PROCESSOR.
*
*  JVS     (INPUT) INTEGER
*          START INDEX OF V.
*
*  JVE     (INPUT) INTEGER
*          END INDEX OF V.
*
* ----------------------------------------------------------------------
*
* LOCAL VARIABLES
*
      INTEGER I,J,IADDR
*
* PARAMETER
*
      COMPLEX*16 ZERO,ONE
      PARAMETER (ZERO=DCMPLX(0.0D0,0.0D0),ONE=DCMPLX(1.0D0,0.0D0))
*
* INITIALIZE V
*
      IADDR=JVBLK(IP+1)-1
      DO J=JVS,JVE
         DO I=1,N
            V(I,J)=ZERO
         ENDDO
         V(IADDR+J,J)=ONE
      ENDDO
*
      RETURN
      END
