      SUBROUTINE J5RANKNB(A,LDA,NB,NLB,JBLSTART2,IPCOL,
     *                   KTMP,KBPIV,PQ,QTPT)
*
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
*
* ARGUMENTS
*
      INTEGER LDA,NB,NLB
      COMPLEX*16 A(LDA,*),PQ(2*NB,NLB*NB),QTPT(2*NB,NLB*NB)
      INTEGER JBLSTART2(NLB)
      INTEGER IPCOL,KTMP,KBPIV
*
* ----------------------------------------------------------------------
*  PURPOSE
*  =======
*
*  J5RANKNB IS RANK-NB MODIFICATION FOR MATRIX A.
*
*  ARGUMENTS
*  =========
*
*  A       (INPUT/OUTPUT) COMPLEX*16 ARRAY, DIMENSION (LDA,*)
*          ON ENTRY,
*          THE PART OF A COMPLEX SYMMETRIC MATRIX FOR TOTAL MATRIX.
*          ON EXIT,
*          RESULT OF RANK-NB MODIFICATION.
*
*  LDA     (INPUT) INTEGER
*          LEADING DIMENSION OF A.
*
*  NB      (INPUT) INTEGER
*          BLOCK SIZE.
*
*  NLB     (INPUT) INTEGER
*          THE NUMBER OF BLOCKS IN MATRIX A.
*
*  JBL     (INPUT) INTEGER ARRAY, DIMENSION (NLB).
*  START2  STARTING ROW POSITION OF THE MATRIX A.
*
*  IPCOL   (INPUT) INTEGER
*          THE COLUMN INDEX OF PROCESS-MAP.
*
*  KTMP    (INPUT) INTEGER
*          STARTING COLUMN BLOCK POSITION OF THE MATRIX A.
*
*  KBPIV   (INPUT) INTEGER
*          THE PIVOT BLOCK INDEX IN THE PROCESS-MAP.
*
*  PQ      (INPUT) COMPLEX*16 ARRAY, DIMENSION (2*NB,NLB*NB).
*          THE COLUMN PIVOT BLOCK ELEMENTARY REFLECTORS.
*
*  QTPT    (INPUT) COMPLEX*16 ARRAY, DIMENSION (2*NB,NLB*NB).
*          THE ROW PIVOT BLOCK ELEMENTARY REFLECTORS.
*
* ----------------------------------------------------------------------
*
* LOCAL VARIABLES
*
      COMPLEX*16 CZ1,CZ2,CZ3,CZ4
      INTEGER I,J,K,L
      INTEGER IS,JS,JE,JTMP,IB,LB,ISTART,IEND,JMOD
*
* PARAMETER
*
      INTEGER JUNRL,IBLK
      PARAMETER (JUNRL=4,IBLK=1000)
*
      JTMP=KTMP
      IF(IPCOL .LE. KBPIV)THEN
         JTMP=KTMP+1
      END IF
*
      JMOD=MOD(NB,JUNRL)
*
* RANK-NB MODIFICATION 4-1 UNROLL AND ROW-BLOCKING
*
      DO L=JTMP,NLB
         JS=(L-1)*NB+1
         JE=L*NB
         IS=(JBLSTART2(L)-1)*NB
         LB=(NLB*NB-IS-1)/IBLK+1
         DO IB=1,LB
            ISTART=IS+(IB-1)*IBLK+1
            IEND  =MIN(IS+IB*IBLK,NLB*NB)
            DO J=JS,JE-JMOD,JUNRL
               DO K=1,2*NB
                  CZ1=QTPT(K,J  )
                  CZ2=QTPT(K,J+1)
                  CZ3=QTPT(K,J+2)
                  CZ4=QTPT(K,J+3)
                  DO I=ISTART,IEND
                     A(I,J  )=A(I,J  )-PQ(K,I)*CZ1
                     A(I,J+1)=A(I,J+1)-PQ(K,I)*CZ2
                     A(I,J+2)=A(I,J+2)-PQ(K,I)*CZ3
                     A(I,J+3)=A(I,J+3)-PQ(K,I)*CZ4
                  ENDDO
               ENDDO
            ENDDO
            DO J=JE-JMOD+1,JE
               DO K=1,2*NB
                  CZ1=QTPT(K,J)
                  DO I=ISTART,IEND
                     A(I,J)=A(I,J)-PQ(K,I)*CZ1
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDDO
*
      RETURN
      END
